Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/TestJob.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/TestJob.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.JobBase/3.3/TestJob.cs	(revision 4091)
@@ -29,10 +29,16 @@
 using System.IO;
 using System.Security.Permissions;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Hive.JobBase {
   [Serializable]
+  [StorableClass]
   public class TestJob: JobBase {
 
+    [Storable]
     private int runValue = 0;
+
+    public TestJob() {
+    }
 
     public override void Run() {
@@ -52,25 +58,21 @@
       OnJobStopped();
     }
-    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, HeuristicLab.Core.IStorable> persistedObjects) {      
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+
+    //public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, HeuristicLab.Core.IStorable> persistedObjects) {      
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
     
-      XmlNode startValue = document.CreateNode(XmlNodeType.Element, "StartValue", null);
-      startValue.InnerText = Convert.ToString(runValue);
+    //  XmlNode startValue = document.CreateNode(XmlNodeType.Element, "StartValue", null);
+    //  startValue.InnerText = Convert.ToString(runValue);
       
-      node.AppendChild(startValue);
-      return node;
-    }
+    //  node.AppendChild(startValue);
+    //  return node;
+    //}
 
-    public override void Populate(XmlNode node, IDictionary<Guid, HeuristicLab.Core.IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
+    //public override void Populate(XmlNode node, IDictionary<Guid, HeuristicLab.Core.IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
 
-      XmlNode startValue = node.SelectSingleNode("StartValue");
-      runValue = Convert.ToInt32(startValue.InnerText);
-    }
-
-    public TestJob() {
-    }
-
-
+    //  XmlNode startValue = node.SelectSingleNode("StartValue");
+    //  runValue = Convert.ToInt32(startValue.InnerText);
+    //}
   }
 }
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ClientCommunicator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ClientCommunicator.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/ClientCommunicator.cs	(revision 4091)
@@ -22,24 +22,15 @@
 using System;
 using System.Collections.Generic;
+using System.IO;
 using System.Linq;
-using System.Text;
+using System.Runtime.Serialization.Formatters.Binary;
+using System.Threading;
+using System.Transactions;
+using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using HeuristicLab.Hive.Contracts.Interfaces;
-using HeuristicLab.Hive.Contracts;
-using HeuristicLab.Core;
-using HeuristicLab.Hive.Server.DataAccess;
-using System.Resources;
-using System.Reflection;
-using HeuristicLab.Hive.JobBase;
 using HeuristicLab.Hive.Server.Core.InternalInterfaces;
-using System.Threading;
 using HeuristicLab.PluginInfrastructure;
-using HeuristicLab.DataAccess.Interfaces;
-using System.IO;
-using System.Runtime.Serialization.Formatters.Binary;
 using HeuristicLab.Tracing;
-using Linq = HeuristicLab.Hive.Server.LINQDataAccess;
-using System.Transactions;
-using HeuristicLab.Hive.Server.LINQDataAccess;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -75,10 +66,8 @@
 
       lifecycleManager = ServiceLocator.GetLifecycleManager();
-      jobManager = ServiceLocator.GetJobManager() as
-        IInternalJobManager;
+      jobManager = ServiceLocator.GetJobManager() as IInternalJobManager;
       scheduler = ServiceLocator.GetScheduler();
 
-      lifecycleManager.RegisterHeartbeat(
-        new EventHandler(lifecycleManager_OnServerHeartbeat));
+      lifecycleManager.RegisterHeartbeat(new EventHandler(lifecycleManager_OnServerHeartbeat));
     }
 
@@ -109,5 +98,5 @@
               foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
                 //maybe implementa n additional Watchdog? Till then, just set them offline..
-                DaoLocator.JobDao.SetJobOffline(job);                                
+                DaoLocator.JobDao.SetJobOffline(job);
               }
             } else {
@@ -168,5 +157,5 @@
             if (pendingJobs[currJob.Id] <= 0) {
               currJob.State = State.offline;
-              DaoLocator.JobDao.Update(currJob);              
+              DaoLocator.JobDao.Update(currJob);
             } else {
               pendingJobs[currJob.Id]--;
@@ -216,12 +205,12 @@
 
       ClientDto client = DaoLocator.ClientDao.FindById(clientId);
-      if(client == null) {
+      if (client == null) {
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_CLIENT_RESOURCE_NOT_FOUND;
         return response;
       }
-      
+
       response.ForceFetch = (client.CalendarSyncStatus == CalendarState.ForceFetch);
-      
+
       IEnumerable<AppointmentDto> appointments = DaoLocator.UptimeCalendarDao.GetCalendarForClient(client);
       if (appointments.Count() == 0) {
@@ -239,5 +228,5 @@
 
     public Response SetCalendarStatus(Guid clientId, CalendarState state) {
-      Response response = new Response();      
+      Response response = new Response();
       ClientDto client = DaoLocator.ClientDao.FindById(clientId);
       if (client == null) {
@@ -246,11 +235,11 @@
         return response;
       }
-      
+
       client.CalendarSyncStatus = state;
       DaoLocator.ClientDao.Update(client);
-      
+
       response.Success = true;
       response.StatusMessage = ApplicationConstants.RESPONSE_UPTIMECALENDAR_STATUS_UPDATED;
-      
+
       return response;
     }
@@ -298,5 +287,5 @@
 
       Logger.Debug("BEGIN Processing Heartbeat Jobs");
-      processJobProcess(hbData, response);
+      ProcessJobProcess(hbData, response);
       Logger.Debug("END Processed Heartbeat Jobs");
 
@@ -306,8 +295,8 @@
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_FETCH_OR_FORCEFETCH_CALENDAR;
         response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchOrForceFetchCalendar));
-        
+
         //client.CalendarSyncStatus = CalendarState.Fetching;
-        
-        Logger.Info("fetch or forcefetch sent");        
+
+        Logger.Info("fetch or forcefetch sent");
       }
 
@@ -338,8 +327,8 @@
     /// <param name="clientAdapter"></param>
     /// <param name="response"></param>
-    private void processJobProcess(HeartBeatData hbData, ResponseHB response) {
+    private void ProcessJobProcess(HeartBeatData hbData, ResponseHB response) {
       Logger.Debug("Started for Client " + hbData.ClientId);
       List<JobDto> jobsOfClient = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfClient(DaoLocator.ClientDao.FindById(hbData.ClientId)));
-      if (hbData.JobProgress != null && hbData.JobProgress.Count > 0) {        
+      if (hbData.JobProgress != null && hbData.JobProgress.Count > 0) {
         if (jobsOfClient == null || jobsOfClient.Count == 0) {
           response.Success = false;
@@ -372,8 +361,8 @@
           DaoLocator.JobDao.Update(curJob);
         }
-       }
+      }
       foreach (JobDto currJob in jobsOfClient) {
         bool found = false;
-        if(hbData.JobProgress != null) {
+        if (hbData.JobProgress != null) {
           foreach (Guid jobId in hbData.JobProgress.Keys) {
             if (jobId == currJob.Id) {
@@ -428,5 +417,5 @@
       JobDto job2Calculate = scheduler.GetNextJobForClient(clientId);
       if (job2Calculate != null) {
-        response.Job = job2Calculate;        
+        response.Job = job2Calculate;
         response.Job.PluginsNeeded = DaoLocator.PluginInfoDao.GetPluginDependenciesForJob(response.Job);
         response.Success = true;
@@ -437,5 +426,5 @@
             newAssignedJobs.Add(job2Calculate.Id, ApplicationConstants.JOB_TIME_TO_LIVE);
         }
-      } else {                  
+      } else {
         response.Success = false;
         response.Job = null;
@@ -449,20 +438,14 @@
     }
 
-    public ResponseResultReceived ProcessJobResult(
-      Stream stream,
-      bool finished) {
-
+    public ResponseResultReceived ProcessJobResult(Stream stream, bool finished) {
       Logger.Info("BEGIN Job received for Storage - main method:");
 
-
-      Stream jobResultStream = null;
-      Stream jobStream = null;
+      //Stream jobResultStream = null;
+      //Stream jobStream = null;
 
       //try {
-      BinaryFormatter formatter =
-        new BinaryFormatter();
-
-      JobResult result =
-        (JobResult)formatter.Deserialize(stream);
+      BinaryFormatter formatter = new BinaryFormatter();
+
+      JobResult result = (JobResult)formatter.Deserialize(stream);
 
       //important - repeatable read isolation level is required here, 
@@ -487,15 +470,15 @@
         List<byte> serializedJob = new List<byte>();
         int read = 0;
-        int i = 0;        
-        while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {          
+        int i = 0;
+        while ((read = stream.Read(buffer, 0, buffer.Length)) > 0) {
           for (int j = 0; j < read; j++) {
             serializedJob.Add(buffer[j]);
           }
-          if (i% 100 == 0)
-            Logger.Debug("Writing to stream: " + i);         
+          if (i % 100 == 0)
+            Logger.Debug("Writing to stream: " + i);
           //jobStream.Write(buffer, 0, read);
           i++;
         }
-        Logger.Debug("Done Writing, closing the stream!");               
+        Logger.Debug("Done Writing, closing the stream!");
         //jobStream.Close();
 
@@ -518,13 +501,10 @@
 
       ResponseResultReceived response = new ResponseResultReceived();
-      ClientDto client =
-        DaoLocator.ClientDao.FindById(clientId);
-
-      SerializedJob job =
-        new SerializedJob();
+      ClientDto client = DaoLocator.ClientDao.FindById(clientId);
+
+      SerializedJob job = new SerializedJob();
 
       if (job != null) {
-        job.JobInfo =
-          DaoLocator.JobDao.FindById(jobId);
+        job.JobInfo = DaoLocator.JobDao.FindById(jobId);
         job.JobInfo.Client = job.JobInfo.Client = DaoLocator.ClientDao.GetClientForJob(jobId);
       }
@@ -650,5 +630,5 @@
 
       Logger.Info("Client logged out " + clientId);
-      
+
       Response response = new Response();
 
@@ -680,5 +660,5 @@
 
       return response;
-    } 
+    }
 
     /// <summary>
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DaoLocator.cs	(revision 4091)
@@ -64,5 +64,5 @@
 
     public static void DestroyContext() {
-      if (ContextFactory.Context != null) {
+      if (ContextFactory.IsContextNull()) {
         ContextFactory.Context.Dispose();
         ContextFactory.Context = null;
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/DbTestApp.cs	(revision 4091)
@@ -24,20 +24,12 @@
 using System;
 using System.Collections.Generic;
-using System.Data.SqlClient;
-using System.Text;
+using System.IO;
+using System.Threading;
+using System.Transactions;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.Core;
+using HeuristicLab.Hive.Server.LINQDataAccess;
 using HeuristicLab.PluginInfrastructure;
-using System.Net;
-using HeuristicLab.Hive.Contracts;
-using HeuristicLab.Hive.Contracts.Interfaces;
-using HeuristicLab.Hive.Server.DataAccess;
-using HeuristicLab.Hive.Contracts.BusinessObjects;
-using System.Diagnostics;
-using HeuristicLab.DataAccess.Interfaces;
-using System.IO;
-using HeuristicLab.Hive.Server.Core;
-using HeuristicLab.Core;
-using HeuristicLab.Hive.Server.LINQDataAccess;
-using System.Transactions;
-using System.Threading;
 using HeuristicLab.Tracing;
 
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ClientFacade.cs	(revision 4091)
@@ -0,0 +1,142 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.PluginInfrastructure;
+using System.IO;
+using System.Runtime.Serialization.Formatters.Binary;
+using System.ServiceModel;
+using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using System.Transactions;
+
+namespace HeuristicLab.Hive.Server.Core {
+  [ServiceBehavior(InstanceContextMode =
+    InstanceContextMode.PerCall, ConcurrencyMode = ConcurrencyMode.Multiple)]
+  public class ClientFacade: IClientFacade {
+
+    public ClientFacade() {      
+    }
+
+    private IClientCommunicator clientCommunicator = ServiceLocator.GetClientCommunicator();
+
+    #region IClientCommunicator Members
+
+    public Response Login(ClientDto clientInfo) {
+      return clientCommunicator.Login(clientInfo);
+    }
+
+    public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
+      return clientCommunicator.ProcessHeartBeat(hbData);
+    }
+
+    public ResponseJob SendJob(Guid clientId) {
+      return clientCommunicator.SendJob(clientId);
+    }
+
+    /*public ResponseSerializedJob SendSerializedJob(Guid clientId) {
+      return clientCommunicator.SendSerializedJob(clientId);
+    } */
+
+    public ResponseResultReceived StoreFinishedJobResult(Guid clientId,
+      Guid jobId,
+      byte[] result,
+      double percentage, 
+      Exception exception) {
+      return clientCommunicator.StoreFinishedJobResult(clientId, jobId, result, percentage, exception);
+    }
+
+    public Response Logout(Guid clientId) {
+      return clientCommunicator.Logout(clientId);
+    }
+
+    public Response IsJobStillNeeded(Guid jobId) {
+      return clientCommunicator.IsJobStillNeeded(jobId);
+    }
+
+    public ResponsePlugin SendPlugins(List<HivePluginInfoDto> pluginList) {
+      return clientCommunicator.SendPlugins(pluginList);
+    }
+
+    public ResponseResultReceived ProcessSnapshot(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
+      return clientCommunicator.ProcessSnapshot(clientId, jobId, result, percentage, exception);
+    }
+
+
+    public ResponseCalendar GetCalendar(Guid clientId) {
+      return clientCommunicator.GetCalendar(clientId);
+    }
+
+    public Response SetCalendarStatus(Guid clientId, CalendarState state) {
+      return clientCommunicator.SetCalendarStatus(clientId, state);      
+    }
+    #endregion
+
+    #region IClientFacade Members
+
+    [SpringTransaction(UserTransaction = true)]
+    public Stream SendStreamedJob(Guid clientId) {
+      MultiStream stream = new MultiStream();
+
+      ResponseJob job = null;
+
+      job = this.SendJob(clientId);      
+
+      //first send response
+      stream.AddStream(new StreamedObject<ResponseJob>(job));
+
+      IJobManager jobManager = ServiceLocator.GetJobManager();
+      IInternalJobManager internalJobManager = (IInternalJobManager) jobManager;
+      
+      //second stream the job binary data
+      MemoryStream memoryStream = new MemoryStream();      
+      if(job.Job != null)
+        stream.AddStream(new MemoryStream(internalJobManager.GetSerializedJobDataById(job.Job.Id)));
+      
+      OperationContext clientContext = OperationContext.Current;
+        clientContext.OperationCompleted += new EventHandler(delegate(object sender, EventArgs args) {
+          if (stream != null) {
+            stream.Dispose();
+          }
+        });
+
+      return stream;
+    }
+
+    public Stream SendStreamedPlugins(List<HivePluginInfoDto> pluginList) {
+      return new StreamedObject<ResponsePlugin>(this.SendPlugins(pluginList));
+    }
+
+    public ResponseResultReceived StoreFinishedJobResultStreamed(Stream stream) {
+      return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, true);
+    } 
+
+    public ResponseResultReceived ProcessSnapshotStreamed(Stream stream) {
+      return ((IInternalClientCommunicator)clientCommunicator).ProcessJobResult(stream, false);
+    }
+    #endregion
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ExecutionEngineFacade.cs	(revision 4091)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class ExecutionEngineFacade: IExecutionEngineFacade {
+
+    private IJobManager jobManager =
+      ServiceLocator.GetJobManager();
+
+    public ExecutionEngineFacade() {
+      
+    }
+
+    #region IExecutionEngineFacade Members
+
+    public ResponseObject<JobDto> AddJob(SerializedJob job) {
+      return jobManager.AddNewJob(job);
+    }
+
+    public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {      
+      return jobManager.AddJobWithGroupStrings(job, resources);
+    }
+
+    public Response RequestSnapshot(Guid jobId) {
+      return jobManager.RequestSnapshot(jobId);
+    }
+
+    public ResponseObject<SerializedJob> 
+      GetLastSerializedResult(Guid jobId, bool requested, bool snapshot) {
+      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+    }
+
+    public Response AbortJob(Guid jobId) {
+      return jobManager.AbortJob(jobId);
+    }
+
+    #endregion
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4091)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/Facades/ServerConsoleFacade.cs	(revision 4091)
@@ -0,0 +1,196 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.Interfaces;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.Security.Contracts.Interfaces;
+using HeuristicLab.Hive.Server.Core.InternalInterfaces;
+using System.ServiceModel;
+
+
+namespace HeuristicLab.Hive.Server.Core {
+  public class ServerConsoleFacade: IServerConsoleFacade {
+    private IClientManager clientManager = 
+      ServiceLocator.GetClientManager();
+
+    private IJobManager jobManager = 
+      ServiceLocator.GetJobManager();
+
+    private IHivePermissionManager secMan = ServiceLocator.GetHivePermissionManager();
+
+    public Guid sessionID = Guid.Empty;
+
+    public ServerConsoleFacade() {      
+    }
+
+    public Response Login(string username, string password) {
+      Response resp = new Response();
+     
+      sessionID = secMan.Login(username, password);
+      if (sessionID == Guid.Empty) {
+        resp.Success = false;
+        resp.StatusMessage = ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_FAILED;
+      } else {
+        resp.Success = true;
+        resp.StatusMessage =
+          ApplicationConstants.RESPONSE_SERVERCONSOLE_LOGIN_SUCCESS;
+      }
+      return resp;
+    }
+
+
+    public ResponseList<ClientDto> GetAllClients() {
+      secMan.Authorize("AccessClients", sessionID, Guid.Empty);
+      return clientManager.GetAllClients();
+    }
+
+    public ResponseList<ClientGroupDto> GetAllClientGroups() {
+      //secMan.Authorize("AccessClientGroup", sessionID, Guid.Empty);
+      return clientManager.GetAllClientGroups();
+    }
+
+    public ResponseList<UpTimeStatisticsDto> GetAllUpTimeStatistics() {
+      secMan.Authorize("AccessStatistics", sessionID, Guid.Empty);
+      return clientManager.GetAllUpTimeStatistics();
+    }
+
+    public ResponseObject<ClientGroupDto> AddClientGroup(ClientGroupDto clientGroup) {
+      secMan.Authorize("AddClientGroup", sessionID, Guid.Empty);
+      return clientManager.AddClientGroup(clientGroup);
+    }
+
+    public Response AddResourceToGroup(Guid clientGroupId, ResourceDto resource) {
+      secMan.Authorize("AddResource", sessionID, Guid.Empty);                
+      return clientManager.AddResourceToGroup(clientGroupId, resource);
+    }
+
+    public Response DeleteResourceFromGroup(Guid clientGroupId, Guid resourceId) {
+        return clientManager.DeleteResourceFromGroup(clientGroupId, resourceId);
+    }
+
+    public ResponseList<JobDto> GetAllJobs() {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+      return jobManager.GetAllJobs();
+    }
+
+    public ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count) {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+      return jobManager.GetAllJobsWithFilter(jobState, offset, count);
+    }
+
+    public ResponseObject<JobDto> GetJobById(Guid jobId) {
+      secMan.Authorize("AccessJobs", sessionID, jobId);
+      return jobManager.GetJobById(jobId);
+    }
+
+    public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
+      secMan.Authorize("AccessJobs", sessionID, jobId);
+      return jobManager.GetJobByIdWithDetails(jobId);
+    }
+
+    public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
+      secMan.Authorize("AddJob", sessionID, job.JobInfo.Id);
+      return jobManager.AddNewJob(job);
+    }
+
+    public ResponseObject<JobDto> GetLastJobResultOf(Guid jobId) {
+      secMan.Authorize("AccessJobResults", sessionID, jobId);
+      return jobManager.GetLastJobResultOf(jobId);
+    }
+
+    public ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot) {
+      secMan.Authorize("AccessJobResults", sessionID, jobId);
+      return jobManager.GetLastSerializedJobResultOf(jobId, requested, snapshot);
+    }
+
+    public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
+      secMan.Authorize("AccessJobResults", sessionID, jobId);  
+      return jobManager.GetAllJobResults(jobId);
+    }
+
+    public Response RemoveJob(Guid jobId) {
+      secMan.Authorize("RemoveJob", sessionID, jobId);
+      return jobManager.RemoveJob(jobId);
+    }
+
+    public Response RequestSnapshot(Guid jobId) {
+      secMan.Authorize("AccessJobResults", sessionID, jobId);  
+      return jobManager.RequestSnapshot(jobId);
+    }
+
+    public Response AbortJob(Guid jobId) {
+      secMan.Authorize("AbortJob", sessionID, Guid.Empty);
+      return jobManager.AbortJob(jobId);
+    }
+
+    public ResponseObject<List<ClientGroupDto>> GetAllGroupsOfResource(Guid resourceId) {
+      secMan.Authorize("AccessUserGroup", sessionID, Guid.Empty);
+      return clientManager.GetAllGroupsOfResource(resourceId);
+    }
+
+    public Response DeleteClientGroup(Guid clientGroupId) {
+      secMan.Authorize("DeleteClientGroup", sessionID, Guid.Empty);
+      return clientManager.DeleteClientGroup(clientGroupId);
+    }
+
+    public ResponseList<ProjectDto> GetAllProjects() {
+      secMan.Authorize("AccessProjects", sessionID, Guid.Empty);
+      return jobManager.GetAllProjects();
+    }
+
+    public Response CreateProject(ProjectDto project) {
+      secMan.Authorize("CreateProjects", sessionID, Guid.Empty);
+      return jobManager.CreateProject(project);
+    }
+
+    public Response ChangeProject(ProjectDto project) {
+      secMan.Authorize("ChangeProjects", sessionID, Guid.Empty);
+      return jobManager.ChangeProject(project);
+    }
+
+    public Response DeleteProject(Guid projectId) {
+      secMan.Authorize("DeleteProjects", sessionID, projectId);
+      return jobManager.DeleteProject(projectId);
+    }
+
+    public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+      return jobManager.GetJobsByProject(projectId);
+    }
+
+    public ResponseList<AppointmentDto> GetUptimeCalendarForResource(Guid guid) {
+      return clientManager.GetUptimeCalendarForResource(guid);
+    }
+
+    public Response SetUptimeCalendarForResource(Guid guid, IEnumerable<AppointmentDto> appointments, bool isForced) {
+      return clientManager.SetUptimeCalendarForResource(guid, appointments, isForced);
+    }
+
+    public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {
+      return jobManager.AddJobWithGroupStrings(job, resources);
+    }
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4090)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server.Core/3.3/HeuristicLab.Hive.Server.Core-3.3.csproj	(revision 4091)
@@ -78,4 +78,7 @@
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
       <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Tracing-3.3">
+      <HintPath>..\..\..\..\..\..\..\..\..\Programme\HeuristicLab 3.3\HeuristicLab.Tracing-3.3.dll</HintPath>
     </Reference>
     <Reference Include="System" />
@@ -136,5 +139,4 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
     <None Include="HeuristicLab.snk" />
     <EmbeddedResource Include="Authorization\HivePermissionSet.xsd">
@@ -161,4 +163,12 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.DataAccess\3.3\HeuristicLab.DataAccess-3.3.csproj">
+      <Project>{9076697B-C151-46CD-95BC-1D059492B478}</Project>
+      <Name>HeuristicLab.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.Contracts\3.3\HeuristicLab.Hive.Contracts-3.3.csproj">
+      <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
+      <Name>HeuristicLab.Hive.Contracts-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Hive.Server.DataAccess\3.3\HeuristicLab.Hive.Server.DataAccess-3.3.csproj">
       <Project>{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}</Project>
